/*
    function for spin-configurations,
    p.e. get the index from config or reverse, get symetric conf.
    - look at block_no
  
 */
#include "lintab.h"
#include "mem.h"
#include "tbase.h"
#include "ansatz.h"
#include "array_m.h"
#ifdef CONFIG_PTHREAD
#include <pthread.h>
#endif

ULLong  npa[NN+1][NN+1][NN+1];   /* tabellierte Fakultaeten	*/

zahl fak(int i){zahl r=1.0;int j;for(j=2;j<=i;j++)r*=j;return(r);}
/* ------------------------------------------------------
 *  calculate the binominal coefficient (use pascal triangle(?))
 *  over(n,k) = n!/((n-k)!k!) = over(n-1,k-1)*n/k = over(n-1,k)+over(n-1,r-1)
 * --------------------------------------------------------- */
ULLong over(int n,int k){
  static ULLong pascal[2*NN+1][2*NN+1]; static int ok=0; int i,j;
  if(!ok){ ok=1;		/* Pascal-Dreieck bauen */
    for(i=0;i<=2*NN;i++)for(j=0;j<=2*NN;j++)pascal[i][j]=(ULLong)((j)?0l:1l);
    for(i=1;i<=2*NN;i++)for(j=1;j<=i;j++)
      pascal[i][j]=pascal[i-1][j]+pascal[i-1][j-1];	/* OVL ? */
  }  
  if(n>2*NN || k>n) return 0l;		/* NN => 2*NN  Nov98 JS */ 
  return pascal[n][k]; /* only 0<=k<=n<=NN */    
}


#if CM(1,1,0)  
/* Perm. mit Wdhlg (3 Elemente)=(o+u+d)!/(o!u!d!)=over(n-u,d)*over(n,u) */
 ULLong np(int o,int u,int d){ return(over(o+u+d,u)*over(o+d,d));}
#else	/* Produkt 2er Kombinat. (2 Elemente)=(n over u)(n over d) */
 ULLong np(int n,int u,int d){return(over(n,u)*over(n,d));}
#endif
void   paini(){ int a,b,c;
    for(a=0;a<=NN;a++)for(b=0;b<=NN;b++)
    for(c=0;c<=NN;c++)npa[a][b][c]=np(a,b,c);
    return;}
    
/* number of spin configurations (nn,nu,nd), same as n1 without Sym */
ULLong numkonf(){ return(npa[nn-CM(1,1,0)*(nu+nd)][nu][nd]);}

/* --------------------------------------------------------------------*
 *                    in-out-functions
 * call this function not more than 5 times within one printf() :) 
 * .=empty-site, u=up, d=down, 3=up+down 
 * ------------------------------------------------------------------- */
char *ckfg(tbase ic){ /* Spinkonfiguration |..43210> zB: |...u.dudu> */
    static char s1[5*(NN+1)],s2[5]=".ud3",*s3;static int x=0;int i;
    x++;x%=5;s3=s1+x*(NN+1);
    if (ic>>nn) E1("ckfg: unused bits are set! %08x",(int)ic);
    for(i=0;i<nn;i++)s3[i]=s2[ geti(ic,nn-i-1) ];
    s3[nn]='\0';return((char *)s3);}

/* ----------------------------------------------------------------------- * 
 * Symmetrienutzung   PermOp(ip)*ib1=s*ib2 , s=+1/-1 ip=permutationsvekt. 
 * ----------------------------------------------------------------------- */
/*   example:
 P = [0 2 1 3] = (0) (1,2) (3)
 ib1= (.. du .u d.) = sites (3 2 1 0) = bits (76 54 32 10)
 m1=7=3d -
 m1=6=3u -						 code2(uuuu,dddd)
 m1=5=2d m2=3=1d i2=(.. .. d. ..) s=0       i3=(11 11 10 00)=(0000,1110)
 m1=4=2u m2=2=1u i2=(.. .. du ..) s^=i3_1=0 i3=(00 00 01 00)=(1110,1110)
 m1=3=1d -
 m1=2=1u m2=4=2u i2=(.. .u du ..) s^=i3_3=0 i3=(11 11 01 00)=(0010,1110)
 m1=1=0d m2=1=0d i2=(.. .u du d.) s^=i3_0=0 i3=(00 00 10 10)=(0010,0001)
 m1=0=0u -      
 ------------------------------------------------------------------------ */
/* ms!=0 multiply phase with k */
/* static inline */
void get_symkonfig(tbase ib1,int ip,tbase *ib2,tphase *ss,int ms){
  tbase i2;  int m1,m2;
#if CM(0,1,1)
  tbase i3;int s;
#endif
  *ib2=ib1;*ss=+1;if(ip<0)return; /* 1-Operator (0,identity) */
#if CM(0,1,1)
#if code2			/* code verbessern! */
  i3.u=i3.d=i2.u=i2.d=0l;s=0;
  for(m1=2*nn-1;m1>=0;m1--)if( ((m1&1)?(ib1.d>>(m1/2))&1l:(ib1.u>>(m1/2))&1l) ){
    m2=sym.i[ip][m1/2]*2+(m1&1);		/* new index   (m1=>m2) */  
    if(m1&1)i2.d|= (tbase1)1<<(m2/2);		/* move spin to m2 */
       else i2.u|= (tbase1)1<<(m2/2);
    if(m2>0){
    if(m1&1){ s^=((m2>=0)?(i3.u>>(m2/2  )):0) ^ ((m2>=2)?(i3.d>>(m2/2-1)):0); }
       else { s^=((m2>=2)?(i3.u>>(m2/2-1)):0) ^ ((m2>=2)?(i3.d>>(m2/2-1)):0); }
    }   
    if(m1&1)i3.d^=~(tbase1)0<<(m2/2);
       else i3.u^=~(tbase1)0<<(m2/2); }
  (*ss)*=1-2*(s&1);
#else				/* code verbessern! 1-2 loop entfernen */
  i3=i2=0l;s=0;				/* remove from NN-1 to 0 */ 
  for(m1=2*nn-1;m1>=0;m1--)if((ib1>>m1)&1){	/* m1 = old index */
    m2=sym.i[ip][m1/2]*2+(m1&1);		/* m2 = new index */
    i2|= (tbase)1<<m2;				/* move spin to m2 */
    if(m2>0)s^=(int)(1&(i3>>(m2-1))); 	/* number of uebersprungende spins */ 
    i3^=(~(tbase)0)<<m2; }		/* Wirkung (sgn) auf folgende spins */
  (*ss)*=1-2*(s&1);
#endif
#else /* CM(1,0,0) Heisenberg */ 
#if 1 /* || defined(DEBUG) ---------------------------------------- */
  /* old=slow, schneller 1bit-maske>>=1 + m2'=m2-m1, pointer to ip */
  i2=0l;for(m1=0;ib1!=0 && m1<nn;m1++,ib1>>=1)if(1&ib1){ /* faster if nd<=nu */
    m2=sym.i[ip][m1]; i2|=((tbase)1)<<m2;	/* Mai99 bug entfernt */
  }	/* damit kann sym.m entfernt werden!!! ??? und uebergabe &sym.i[ip] statt ip ???  */
#else		/* faster ----kann weg!---------------------------------- */
  i2=0l;for(m1=0;    (m2=sym.d[ip][m1])!=0;m1++){
    if(m2>=0) i2|=(ib1 & sym.m[ip][m1])<< m2;
      else    i2|=(ib1 & sym.m[ip][m1])>>-m2;
  }
  i2|=ib1 & sym.m[ip][m1];	/* case sym.i[i]==i, shift=0 */
#endif /* old -------------------------------------------------------- */
#endif /* JJ */
  *ib2=i2;
  if(ms){
    (*ss)*=sym.w[ip];
#if Zahl & 4
    /* Rundungsfehler ausgleichen */
    if(fabs(imag(*ss))<1e-9) (*ss)=C(real(*ss),0);
#endif
  }  
  return;}

tbase m55=0;    /* dynamic initialisation only in C++ => initmasks */
tbase mAA=0;
tbase m0F=0;

/* initialize bitmasks m55,mAA,m0F */
int initmasks(int nn){
  int i; tbase r=0;
  for(i=0;(unsigned)i<sizeof(tbase)*8;i+=2) r|=((tbase)1)<<i;
  m55=r;
  mAA=r<<1;
  m0F=~(((~(tbase)0)<<(nn-1))<<1); /* (int32)<<32 won't work on x86 */
  /*  printf(" ini55: %s\n",ckfg(r)); */
  return 0;
}
    
/* ----------------------------------------------------------------------- * 
 * Symmetrienutzung   u<->d,   attention: ss may point to s1 !!!
 * ----------------------------------------------------------------------- */
/* static inline */
void get_sudkonfig(tbase ib1,tphase s1,tbase *ib2,tphase *ss){
#if Sud
#if CM(0,0,1)			/* ib2(ss) can also point to ib1(s1) !!! */
  tbase1 i3;
#endif  
#endif
  *ib2=ib1;*ss=s1;		/* default */
#if Sud				/* programm */
  if(nu!=nd) return;
#if CM(1,0,0)
  (*ib2)=ib1 ^ m0F;
#else
#if ! code2
  (*ib2)=((mAA & ib1)>>1) | ((m55 & ib1)<<1);
#if CM(0,0,1)
  for(i3=((tbase)3)<<(2*nn-2);i3!=0;i3>>=2)if((ib1&i3)==i3)(*ss)*=-1; 
#endif
#else /* code2 */
  (*ib2).u=ib1.d; (*ib2).d=ib1.u;
#if CM(0,0,1)
  for(i3=((tbase)1)<<(nn-1);i3!=0;i3>>=1)if(((ib1.u&ib1.d)&i3)!=0)(*ss)*=-1; 
#endif
#endif /* code2 */
#endif   
  (*ss)*=sym.wud;
#endif  /* no Sym */
  return;}

/* --------------------------------------------------------------------	*
 * 		Spin-Konfigurationen ki und deren Index i		*
 * --------------------------------------------------------------------	*/
#define MF(x)   ( ~((~(tbase)0)<<(x)))	/* << only int/long, not longlong */
#define MA(x)   (mAA & MF(x))		/* MF(x) = x * 1 bits */
#define M5(x)   (m55 & MF(x))
#define M1(x)   (  ((tbase)  1)<<(x) )
#define M2(x)   (  ((tbase)  2)<<(x) )
#define M3(x)   (  ((tbase)  3)<<(x) )
#define ME(x)   (  ((tbase)0-2)<<(x) )
#define MC(x)   (  ((tbase)0-4)<<(x) )
#if CM(0,1,0)
#if ! code2
inline tbase next(tbase kfg){                                       /* ki++ */ 
  int i=0,d=0,u=0; 	/* Achtung: ki<<32 bei 32bit nicht definiert*/
  if(kfg&2l)d+=2; else if(kfg&1l)u+=2;
  while((i+=2)<2*nn)switch((int)((kfg>>i)&3l)){
   case 0:       if(u){ u-=2;
     return((kfg & MC(i)) | M1(i) | M5(u)<<d | MA(d));} else if(d){ d-=2;
     return((kfg & MC(i)) | M2(i) | M5(u)<<d | MA(d));} break;
   case 1: u+=2; if(d){ d-=2;
     return((kfg & MC(i)) | M2(i) | M5(u)<<d | MA(d));} break;
   case 2: d+=2;}
  return(M5(u)<<d | MA(d));}

tbase  ll1(ULLong ii){ /* getbasis from index 0..N1-1 */
  ULLong i,t;tbase j;int io,iu,id;
  j=0l;io=nn-nu-nd;iu=nu;id=nd;i=ii+1l;
  for(;;){
   if(io>0){ if(i<=(t=npa[io-1][iu][id])){j=(j<<2);  io--;continue;}i-=t;}
   if(iu>0){ if(i<=(t=npa[io][iu-1][id])){j=(j<<2)|1;iu--;continue;}i-=t;}
   if(id>0){ if(i<=(t=npa[io][iu][id-1])){j=(j<<2)|2;id--;continue;}i-=t;}
   else break;}
  return(j);}
    
ULLong ll2(tbase ii){ /* n-dimensionale Linkodierung */
/* Inp: Spinkonfiguration, Out: Index des Basiszustandes */
    ULLong j=0l;int io,iu,id,i,i1;
    io=nn-nu-nd;iu=nu;id=nd;for(i=nn-1;i>=0;i--){
      i1=(int)(3&(ii>>(2*i)));
      if(i1>0 && io>0)j+=npa[io-1][iu][id];
      if(i1>1 && iu>0)j+=npa[io][iu-1][id];
      if(i1==0)io--;
      if(i1==1)iu--;
      if(i1==2)id--;}
    return(j);}
#else	/* code2 */
inline tbase next(tbase kfg){                                       /* ki++ */ 
  int i=0,d=0,u=0; 	/* Achtung: ki<<32 bei 32bit nicht definiert*/
  if(kfg.d&1)d+=1; else if(kfg.u&1)u+=1;
  while((i++)<nn)switch( geti(kfg,i) ){
   case 0:
     if(u){ u--; return((tbase){(kfg.u & ME(i)) | M1(i) | MF(u)<<d ,
                                (kfg.d & ME(i)) |         MF(d)    });} else
     if(d){ d--; return((tbase){(kfg.u & ME(i)) |         MF(u)<<d ,
                                (kfg.d & ME(i)) | M1(i) | MF(d)    });} break;
   case 1: u++; 
     if(d){ d--; return((tbase){(kfg.u & ME(i)) |         MF(u)<<d ,
                                (kfg.d & ME(i)) | M1(i) | MF(d)    });} break;
   case 2: d++;}
  return((tbase){ MF(u)<<d , MF(d) });}

tbase  ll1(ULLong ii){ /* getbasis from index 0..N1-1 */
  ULLong i,t;tbase j;int io,iu,id;
  j=((tbase){0l,0l});io=nn-nu-nd;iu=nu;id=nd;i=ii+1l;
  for(;;){
   if(io>0){ if(i<=(t=npa[io-1][iu][id])){j.u=(j.u<<1);  j.d=(j.d<<1);  io--;continue;}i-=t;}
   if(iu>0){ if(i<=(t=npa[io][iu-1][id])){j.u=(j.u<<1)|1;j.d=(j.d<<1);  iu--;continue;}i-=t;}
   if(id>0){ if(i<=(t=npa[io][iu][id-1])){j.u=(j.u<<1);  j.d=(j.d<<1)|1;id--;continue;}i-=t;}
   else break;}
  return(j);}
    
ULLong ll2(tbase ii){ /* n-dimensionale Linkodierung */
/* Inp: Spinkonfiguration, Out: Index des Basiszustandes */
    ULLong j=0l;int io,iu,id,i,i1;
    io=nn-nu-nd;iu=nu;id=nd;for(i=nn-1;i>=0;i--){
      i1=(1&(int)(ii.u>>i)) + 2*(1&(int)(ii.d>>i));
      if(i1>0 && io>0)j+=npa[io-1][iu][id];
      if(i1>1 && iu>0)j+=npa[io][iu-1][id];
      if(i1==0)io--;
      if(i1==1)iu--;
      if(i1==2)id--;}
    return(j);}

#endif	/* code2 */

#elif CM(1,0,0)

/* 01101 i=1 d=1 inp  */
/* 01110 i=2 d=1 !!!  */
/* 10011 i=2 d=2      */
/* 10101 i=1 d=1      */
/* 10110 i=2 d=1      */
/* 12233=123=LM
   00011 002 i=2 d=1
   00101 011
   01100 020
   10001 101
   10100 110
 */
/* last change: long long Anpassung 9.4.1998 JS */
/* MP-version Dec99, better readable */
#if defined(SBase) && defined(CONFIG_S1SYM)
static inline tbase next(tbase kfg){	/* ??? */ 
  int i,d,k,j,v=0;	/* i position des ersten 01 musters */
  i=d=0;		/* d anzahl 1bits exclusive 01 muster */
  if(sym.num_lm!=nn){
    if(v&1)printf("\n0 i=%2d d=%2d next=%s",i,d,ckfg(kfg));
    for(;i!=nn;i++){ /* searching 01 bit pattern */
     if(1&(kfg>>i)){ /* loesche spin, wenn kein hoeheres LM */
       for(k=i+1;k<nn;k++)if(sym.lm[k]==sym.lm[i])if(1&(kfg>>k))break;
       if(k==nn)
       for(k=0  ;k<=i;k++)if(sym.lm[k]==sym.lm[i])if(1&(kfg>>k)) 
       { d++;kfg&=~M1(k); }
     }
     else { /* OVL to other LM */
       for(j=0,k=0;k<i;k++)if(sym.lm[k]==sym.lm[i])j++;
       if(d>j)break;
     }
    }
    if(i<nn) { kfg |= M1(i); d--; } else i=d;
    /* erst spins in LM verteilen */
    if(v&2)printf("\n1 i=%2d d=%2d next=%s",i,d,ckfg(kfg));
    for(k=0;k<i && d>0;k++)if(sym.lm[k]==sym.lm[i]){ d--;kfg|=M1(k); }
    /* nun der Rest */
    if(v&4)printf("\n2 i=%2d d=%2d next=%s",i,d,ckfg(kfg));
    for(k=0;k<i && d>0;k++)if(!((kfg>>k)&1)){ d--;kfg|=M1(k); }
    if(v&8)printf("\n3 i=%2d d=%2d next=%s",i,d,ckfg(kfg));
    return(kfg);
  }
  for(;i!=nn;i++){ if((kfg>>i)&1)d++;else if(d)break; }
  return ( (kfg & ~MF(i)) | M1(i) | MF(--d) ); /* d==0: x<<-1 ???  */
}
#else
static inline tbase next(tbase kfg){	/* ??? */ 
  int i,d;		/* i position des ersten 01 musters */
  i=d=0;		/* d anzahl 1bits exclusive 01 muster */
  for(;i!=nn;i++){ if((kfg>>i)&1)d++;else if(d)break; }
  return ( (kfg & ~MF(i)) | M1(i) | MF(--d) ); /* d==0: x<<-1 ???  */
}
#endif

tbase  ll1(ULLong ii){	/* getbasis from index 0..N1-1 */
    ULLong i,t;tbase j;int iu,id;
    j=0l;iu=nu;id=nd;i=ii+1l;if(nn!=nu+nd)F0("nu+nd != NN")
    for(;;){
     if(iu>0){ if(i<=(t=npa[0][iu-1][id])){j=(j<<1)|0;iu--;continue;}i-=t;}
     /* else { j=(j<<id)|MF(id);break; F A S T E R ???? } */
     if(id>0){ if(i<=(t=npa[0][iu][id-1])){j=(j<<1)|1;id--;continue;}i-=t;}
     break;}
    return(j);}
    
ULLong ll2(tbase ii){	/* n-dimensionale Linkodierung */
/* Inp: Spinkonfiguration, Out: Index des Basiszustandes */
    ULLong j=0l;int iu,id,i,i1;
    iu=nu;id=nd;if(nn!=nu+nd)F0("nu+nd != NN")
    for(i=nn-1;i>=0;i--){
      i1=1&(int)(ii>>i);
      if(i1>0 && iu>0 && id>0)j+=npa[0][iu-1][id];
      if(i1==0)iu--;
      if(i1==1)id--;}
    return(j);}

#elif CM(0,0,1)

#if ! code2
inline tbase next(tbase kfg){  				/* ki++ */ 
  int i,d,u;if(kfg&1l)u=2;else u=0;if(kfg&2l)d=2;else d=0;  
  for(i=2;i<2*nn;i+=2)switch((int)(3&(kfg>>i))){      /* -1<<2=-4 */
   case 0:
    if(u){ return((kfg & MC(i)) | M1(i) | M5(u-2) | MA(d));} else 
    if(d){ return((kfg & MC(i)) | M2(i) | M5(u) | MA(d-2));} break;
   case 1:  u+=2; 
    if(d){ return((kfg & MC(i)) | M2(i) | M5(u) | MA(d-2));} break;
   case 2:
    if(u){ return((kfg & MC(i)) | M3(i) | M5(u-2) | MA(d));} d+=2; break;
   case 3:  u+=2;d+=2;}
  return( M5(u) | MA(d) );}

tbase  ll1(ULLong ii){	/* get konfiguration from index 0..N1-1 */
    tbase j;int in,iu,id;ULLong i,t;i=ii;j=0l;iu=nu;id=nd;
    for(in=nn-1;in>=0;in--){
     if(in>=iu && in>=id){
         if(i<(t=npa[in][iu  ][id  ])){continue;}i-=t;}
     if(iu>0 && in>=id){
         if(i<(t=npa[in][iu-1][id  ])){j|=M1(2*in);iu--;continue;}i-=t;}
     if(id>0 && in>=iu){
         if(i<(t=npa[in][iu  ][id-1])){j|=M2(2*in);id--;continue;}i-=t;}
     if(id>0 && iu>0)
         if(i<   npa[in][iu-1][id-1] ){j|=M3(2*in);id--;iu--;continue;}
     break;}
    return(j);}
    
ULLong ll2(tbase ii){                /* ki -> i */
    ULLong j;int iu,id,i,i1;j=0l;iu=nu;id=nd;
    for(i=nn-1;i;i--){ if(i<iu)if(i<id)break;i1=3&(ii>>(i<<1));
      if(i1>0){  if(i>=iu   && i>=id        )j+=npa[i][iu  ][id];
       if(i1>1){ if(i>=iu-1 && i>=id && iu>0)j+=npa[i][iu-1][id];id--;
        if(i1>2){if(i>=iu   && i>=id        )j+=npa[i][iu  ][id];iu--;}}
       else iu--;}}
    return(j);}
#else
inline tbase next(tbase kfg){  				/* ki++ */ 
  int i,d,u;
  if(kfg.u&1l)u=1;else u=0;
  if(kfg.d&1l)d=1;else d=0;  
  for(i=1;i<nn;i++)switch( (1&(kfg.u>>i)) + 2*(1&(kfg.d>>i)) ){ /* -1<<2=-4 */
   case 0:
    if(u){ return((tbase){(kfg.u & ME(i)) | M1(i) | MF(u-1) , 
                          (kfg.d & ME(i)) |         MF(d)   });} else
    if(d){ return((tbase){(kfg.u & ME(i)) |         MF(u)   ,
                          (kfg.d & ME(i)) | M1(i) | MF(d-1) });} break;
   case 1:  u++;
    if(d){ return((tbase){(kfg.u & ME(i)) |         MF(u)   ,
                          (kfg.d & ME(i)) | M1(i) | MF(d-1) });} break;
   case 2:
    if(u){ return((tbase){(kfg.u & ME(i)) | M1(i) | MF(u-1) ,
                          (kfg.d & ME(i)) | M1(i) | MF(d)   });} d++; break;
   case 3:  u++;d++;}
  return((tbase){ MF(u), MF(d) });}

tbase  ll1(ULLong ii){	/* get konfiguration from index 0..N1-1 */
  tbase j;int in,iu,id;ULLong i,t;i=ii;j=((tbase){0l,0l});iu=nu;id=nd;
  for(in=nn-1;in>=0;in--){
   if(in>=iu && in>=id){ if(i<(t=npa[in][iu  ][id  ])){continue;}i-=t;}
   if(iu>0   && in>=id){ if(i<(t=npa[in][iu-1][id  ])){j.u|=M1(in);iu--;continue;}i-=t;}
   if(id>0   && in>=iu){ if(i<(t=npa[in][iu  ][id-1])){j.d|=M1(in);id--;continue;}i-=t;}
   if(id>0   && iu>0)    if(i<   npa[in][iu-1][id-1] ){j.u|=M1(in),j.d|=M1(in);id--;iu--;continue;}
   break;}
  return(j);}
    
ULLong ll2(tbase ii){                /* ki -> i */
  ULLong j;int iu,id,i,i1;j=0l;iu=nu;id=nd;
  for(i=nn-1;i;i--){ if(i<iu)if(i<id)break;i1=(1&(ii.u>>i)) + 2*(1&(ii.d>>i));
   if(i1>0){  if(i>=iu   && i>=id        )j+=npa[i][iu  ][id];
    if(i1>1){ if(i>=iu-1 && i>=id && iu>0)j+=npa[i][iu-1][id];id--;
     if(i1>2){if(i>=iu   && i>=id        )j+=npa[i][iu  ][id];iu--;}}
    else iu--;}}
  return(j);}
#endif /* code2 */
#endif
#undef MF
#undef MA
#undef M5
#undef M1
#undef M2
#undef M3
#undef MC
#undef ME

/* suche entry in sorted tab[0..l-1], not found => 0 */
/* ToDo: it should be easier with uuu and ddd-tab if tU */
ULong findkfg(tbase entry, ULong l){
  ULong j,m;j=0l;  /* v203 tbase1=>ULong, 98: ULong=>tbase1 */
#if (CM(1,2,2)*NN-1)>8*S_long-1
  m=~(~(ULong)0u>>1);		/* set msb (highest bit) */
#else
  m=((ULong)1)<<(CM(1,2,2)*nn-1);
  if(m==0 || m==1)F0("OVL");
#endif
  while(m){if((j|m)<l)	/* long unsigned == unsigned long ? */
    if(getl1(j|m)<=entry) j|=m;
    m>>=1;
  }
  /* if(getl1(j)!=entry)j=0l;			 not found */
  return((ULong) j);			/* ULong/tbase1 ??? */
}

/* ------------------------ Symmetrische Basis (class base) ---- *
 * inp: sym.k[], sym.i[] 
 * out: |rc)=sign(s)*|s|^(-1/2)*|rc],  s=<ib1|rc)
 * |] is sym-base, summe aller zu |ib1> symmetr. konfigs 
 * |) is normed sym-base, 
 * |> is spin-configuration (1st base) 
 * ------------------------------------------------------------- */
 
/* is=0 nicht storen! bzw. hinten, is!=0 nach vorn, .num kleiner nj */


/* b->o: 0=getbase     sign,norm2,skfg,num,ib[],is[] ok
 *       1=smallest    sign,norm2,skfg ok ???
 *       2=ifsmallest  sign,skfg if(smallest)(norm2) ok, num=0
 */
int b_out(struct sbase *b,int len){	/* JS Mai99, bug: b to *b Nov99 */
  int i;if(len==0)len=b->num;
  printf("\n sign=%s norm2=%4g num=%4d o=%d skfg=%s",
    outphase(b->sign),(double)b->norm2,b->num,b->o,ckfg(b->skfg));
  for(i=0;i<len && i<b->num;i++) 
    printf("\n%3d %s %s",i,outphase(b->is[i]),ckfg(b->ib[i]));
  return 0;
}

#if Zahl & 4		/* used in b_getbase... */
#define ABS1(x) ((int)(fabs(x)+.5))
#else
#define ABS1(x) abs(x)
#endif

#if 0
/* ---- Phasenfaktoren in b_getbase kuerzen, norm2 ermitteln, Jan00 ---- */
void b_putnorm(struct sbase *b){  
  int nm,n2,j,ks;
  for(nm=n2=j=0;j<b->num;j++){
    ks=ABS1(b->is[j]);					/* summierte Phase */
    if(ks){ 
      if(!nm) nm=ks; else 		/* merke Betrag */
      if(nm!=ks){ b_out(b,40);F2("sym.is differ from nm=%d at j=%d",nm,j); }
      n2+=1; if(nm) b->is[j]/=nm; else F0("nm=0");	/* simplify */
      if(b->skfg==b->ib[j]) b->sign=b->is[j];	/* new */
    }           
  } 
  b->norm2=n2; if(!n2) b->sign=(tphase)0; return;
}
#endif

/* --- ax|vx>+...+1|vx> => (ax+1)|vx>+...+0|vx> --- ib[num] already stored */
/* 0-entries durch (b.num-1)-entries ersetzen und b.num-- (packen) ???? 
 * gleiche kfg-entrys mit verschiedenen signen interferieren zu 0! 
 * twice ist 0, wenn der mutterfunktion der Faktor twice bekannt ist
 *    kann die Neuberechnung gespart werden
 */
void b_twice(struct sbase *b,int twice){  
  int k,j,num/* ,t */;
  if(twice==0)
  for(num=0;num<b->num;num++) if (b->ib[num]==b->skfg) twice++;
  if(b->o!=2 && twice>1)
  for(num=0;num<b->num;num++) if (ABS1(b->is[num])) {
    for(k=num+1,j=twice;k<b->num && j>0;) if (b->ib[k]==b->ib[num]) {
      b->num--;j--;
      b->is[k]=b->is[b->num];		/* tabelle kuerzen */
      b->ib[k]=b->ib[b->num];
    } else k++; /* Jan03: "else" correct? new {} */
  }
  b->norm2=b->num;
  return;
}

/* ---- get_lm_factor ---- */
ULLong b_factor_lm(tbase ib1){  
  int k,b1,i1,obj[NN][4];
  ULLong n2,factor;
  n2=1;	
  if(sym.num_lm==nn) return(n2);
  /* bestimme faktor (n1+n2+n3+n4)!/(n1!n2!n3!n4!) =
       = (n1+n2+n3+n4)!/n1! * (n2+n3+n4)!/n2! * (n3+n4)!/n3!
   */
  for(k=0;k<nn;k++){ obj[k][0]=obj[k][1]=obj[k][2]=obj[k][3]=0; } 
  for(i1=0;i1<nn;i1++){
      b1=geti(ib1,i1); obj[sym.lm[i1]][b1]++;
  }
  for(k=0;k<nn;k++)if(sym.lm[k]==k){
      factor=over(obj[k][0]+obj[k][1]+obj[k][2]+obj[k][3],obj[k][3])
            *over(obj[k][0]+obj[k][1]+obj[k][2]          ,obj[k][2])
            *over(obj[k][0]+obj[k][1]                    ,obj[k][1]);
#ifdef DEBUG
      if( (double)n2*factor != n2*(double)factor ) ERR(9110);
#endif
      n2*=factor;
  }
  return(n2);
}

/* ---- nach getbase Sym_lm anwenden! Jan00 v0.2 ---- */
/* P500 bcc16 n1=5 66s/134s/169s/303s ??? e0=-20,-17,-10,1
   v0.2 25Feb2000  1s/1s/1s/3s norm2=2+128+1568+6272+4900 !!!
                         
 */
tbase b_getbase_lm(struct sbase *b){  
  tbase ib0,ib2;int k,b1,b2,i1,i2; tphase s1;
  int i3,j,n2;
#if CM(0,1,1)	/* signum ??? */
  static int err0=1;
  if(err0){
    E0("Warning! getbase_lm does propably not work! check it without S1SYM!");
    err0=0;
  }
#endif      
  n2=b->num;	/* momentanes ende */
  for(j=0;(ULLong)j<(ULLong)b->num;j++){
   /* erzeuge kleinstes lm! (ausreichend fuer ifsmallest)
    * und Zaehle .,u,d,ud in k[lm] fuer faktor (n1+n2+n3+n4)!/(n1!n2!n3!n4!) */
   ib0=b->ib[j]; s1=b->is[j];	/* not very efficient */
   for(i1=0;i1<nn-1;i1++)for(i2=i1+1;i2<nn;i2++)if(sym.lm[i1]==sym.lm[i2])
   if((b1=geti(ib0,i1))!=(b2=geti(ib0,i2))){ /* exchange sym-sites */
       ib2=puti(puti(ib0,i1,b2),i2,b1);
       if(b->skfg==ib2){	/* Mar00 */
         if(!phase_eq(s1,b->sign)){b->sign=0;b->num=0;return b->skfg;}
       }
       if(!(ib0<=ib2)){ ib0=ib2;
         if(!(b->skfg<=ib0)){ b->skfg=ib0;b->sign=s1;if(b->o==2)return ib2; }
       }
   }
   b->ib[j]=ib0;	/* smallest_lm */
   for(i3=0;i3<j;i3++)if(ib0==b->ib[i3])break; /* already stored? */
   if(i3<j){b->num--;b->is[j]=b->is[b->num];b->ib[j]=b->ib[b->num];j--;continue;} /* yes -> do not store twice, pack??? */
  }
  n2=1;	
  if(b->o<2){	/* (n1+n2+n3+n4)!/(n1!n2!n3!n4!) */
    n2=(int)b_factor_lm(b->skfg); /* ULLong -> int ??? */
  }
  if(b->o==1){ b->norm2=b->num*n2; return(b->skfg); }

  n2=b->num;
  if(b->o<1)	/* get all states! really slowly! */
  for(k=0;k<nn;k++)
  for(i1=   0;i1<nn-1;i1++)if(sym.lm[i1]==k)
  for(i2=i1+1;i2<nn  ;i2++)if(sym.lm[i2]==k)
  for(j=0;j<n2;j++){
   ib0=b->ib[j]; s1=b->is[j];	/* not very efficient */

   if((b1=geti(ib0,i1))!=(b2=geti(ib0,i2))){ /* exchange sym-sites */
      ib2=puti(puti(ib0,i1,b2),i2,b1);
      if(n2>=MaxSBase){ ERR(520); err_fatal=520; return(b->skfg); }
      b->ib[n2]=ib2; b->is[n2]=s1;
      
      for(i3=0;i3<n2;i3++)if(ib2==b->ib[i3])break; /* already stored? */
      if(i3<n2) continue; /* yes -> do not store twice */
      n2++;
   }
  } 
  b->num=n2; b->norm2=n2; if(!n2) b->sign=(tphase)0;
  return(b->skfg);}

/* erzeugt nur kleinere Konfiguration wenn erstes bit in sbase=1 CM(JJ) */
void b_getbase_ud(struct sbase *b){  /* bei Sz!=0 Verschwendung! */
  tbase ib0,ib1,ib2;int i,j,nj; tphase s1;
  j=nj=b->num;ib0=b->skfg;ib1=b->ib[0];
  for(i=0;i<nj;i++)/* if(b->is[i]!=0) */{
    get_sudkonfig(b->ib[i],b->is[i],&ib2,&s1);	/* s|ib2>=T|ib1> */
    if(!(ib0<=ib2)){b->skfg=ib0=ib2;b->sign=s1;if(b->o==2)return; }
    if( (ib1==ib2)){
      if(!phase_eq(s1,b->is[0])){b->sign=0;b->num=0;return;}
      j=nj;break; /* wegen |symkfg>=Tud|symkfg> Jan00 */
    }
    b->ib[j]=ib2; b->is[j]=s1; j++;
  }
  b->norm2=b->num=j; return; }

/* ---- long=+uudd+uudd -> short=2uudd+0uudd ---- */
/* schneller, wenn symkonfig und sudkonfig nacheinander ausgefuehrt werden??? */
/* kuerzen als extra-funktion ??? redundanter code .._lm */
/* besser index to smallest merken? (temporaer) SORTIEREN??? */
/* cache anlegen ??? oder nur verschiedene kfgs erzeugen */
/* n1_sym ist ca. n1/sym, d.h. ib1==ib2 | twice>1 ist selten -> einsparung? */
tbase b_getbase(tbase ib1,struct sbase *b){  
  tbase ib0,ib2;int j,n2,nj=sym.numall+1; tphase s1;
  b->ib[0]=b->skfg=ib0=ib1;b->is[0]=b->sign=1;n2=1;
  if(nj*((nu==nd)?2:1)>MaxSBase)F0("MaxSBase-OVL, enlarge it!?");
  for(j=1;j<nj;){ s1=1;
    get_symkonfig(ib1,((unsigned)j)-1,&ib2,&s1,1);
    if(!(ib0<=ib2)){b->skfg=ib0=ib2;b->sign=s1;if(b->o==2)return ib2;}
    if( (ib1==ib2)){
      if(!phase_eq(s1,1)){b->sign=0;b->num=0;return ib2;} n2++; }
    b->ib[j]=ib2; b->is[j]=s1;
    j++;
  }
  b->num=nj; b->norm2=nj*n2; if(n2>1) b_twice(b,n2);
  if(nu==nd) b_getbase_ud(b);
#if defined(CONFIG_S1SYM)    /* geht noch nicht */
  if(sym.num_lm!=nn) b_getbase_lm(b);
#endif
  /* b_out(b,b->num); */
  return(b->skfg);}

/* ACHTUNG bei is[smallestkfg]=0 !!! sign von ib1 */           
/* 1=true 0=false, ud-test nur sinnvoll wenn erste spin=d!!!faster since Jan00 */
int b_ifsmallest(tbase ib1, struct sbase *b){ 
  int old_o;
  old_o=b->o;b->o=2; b_getbase(ib1,b); b->o=old_o;
  /* printf("\nkfg=%s: ",ckfg(ib1));b_out(b,0); */
  if((!(ib1==b->skfg)) || b->norm2==0 || phase_eq(b->sign,0)) return 0;
  b->sign=1; b->num=0;				/* not given here */
  return 1;}

#define Err17 {static int e0=1;if(e0){ E0("b_smallest_lm may be buggy! check it without S1SYM!"); e0=0;}}

int b_ifsmallest_lm(tbase ib0){
  int i1,i2; CM({},Err17,Err17) /* code2 ??? */
  for(i1=0;i1<nn-1;i1++)
  for(i2=i1+1;i2<nn;i2++) if(sym.lm[i1]==sym.lm[i2]) {
    if(geti(ib0,i1)<geti(ib0,i2)){
      return 0;
    }
  }
  return 1;
}

/* erzeuge kleinstes lm! (ausreichend fuer smallest) */
tbase b_smallest_lm(tbase ib0){  
  int b1,b2,i1,i2; CM({},Err17,Err17)	/* signum ??? */
  for(i1=0;i1<nn-1;i1++)
  for(i2=i1+1;i2<nn;i2++) if(sym.lm[i1]==sym.lm[i2]) {
    if((b1=geti(ib0,i1))<(b2=geti(ib0,i2))){
     ib0=puti(puti(ib0,i1,b2),i2,b1); /* exchange sym-sites */
     /* i1=-1; i2=nn; ??? */
    }
  }
  return(ib0);
}
 
/* 1=true 0=false, geht etwa doppelt so schnell, wie alte Variante */
int b_ifsmallest3(tbase ib1, struct sbase *b){ 
  char k1[NN],k2[NN],*k3,i2; int i,j,n2,d;  tphase s1,s2,s3;
  signed char *ps;    tbase ib2;
  b->sign=0; n2=1; s2=+1;
  if(nu==nd) get_sudkonfig(ib1,+1,&ib2,&s2);	/* s|ib2>=T|ib1> */
#if defined(CONFIG_S1SYM) /* return b_ifsmallest(ib1,b); */
  if(sym.num_lm!=nn) {
    if( !b_ifsmallest_lm(ib1) ) return 0; /* tritt nie auf!? */
    if(nu==nd) ib2=b_smallest_lm(ib2); 
  }
#endif
  if(nu==nd){
    if(!(ib1<=ib2)){ return 0;}
    if( (ib1==ib2)){ if(s2!=1){ return 0; } n2=2; }
    for(i=0;i<nn;i++) k2[i]=geti(ib2,i);
  } else ib2=ib1;
  for(i=0;i<nn;i++) k1[i]=geti(ib1,i);
  for(i2=0,k3=k1,s3=1;;i2++,k3=k2,s3=s2){  /* ud=+1,-1 */
    for(j=0;j<sym.numall;j++){
      for(ps=&sym.i[ j ][i=nn-1];;){	/* Tj, high -> low */
        if((d=k1[i]-k3[*(ps--)])<0) break;
        if(d!=0) return 0; if((--i)>=0) continue;
#if CM(1,0,0)  /* signum is not cfg-dependend */
        s1=sym.w[j];			/* T|x>=t|x> same konfig */
#elif CM(0,1,1)  /* signum is cfg-dependend */
        tbase ib4;
        get_symkonfig(((i2)?ib2:ib1),j,&ib4,&s1,1);
#endif
        if(!phase_eq(s1*s3,1)) return 0;
        n2++; break;
      }
    }
    if(nu!=nd || i2==1) break; /* Sep00 */
    IFww( break; )
  }
  b->skfg=ib1;b->sign=1;b->num=0; /* not given here */
  b->norm2=(((nu==nd)?2:1)*(sym.numall+1))/n2; /* OK ??? */
#ifdef CONFIG_S1SYM
  b->norm2*=b_factor_lm(ib1);	/* Ok ??? */
#endif
  /* b_out(b,0); */
  return 1;}
  
/* --- last change 1998-169 JS --- */
/* static inline */ /* needed in spins.h -> xval.c */
/*
   k1 - config ib1
   k2 - config ib1 or ist ud-symmetric one
   ks - smallest config found actually 
 */
tbase b_smallest(tbase ib1, struct sbase *b){ 
  char k1[NN],k2[NN],ks[NN],*k3,i2; int i,j,k,n2,d; tphase s1,s2,s3;
  signed char *ps;  tbase ib2,ib3;
  b->sign=1;  b->skfg=ib1; b->norm2=1;	/* default minimum */
  n2=1;get_sudkonfig(ib1,+1,&ib2,&s2);	/* s|ib2>=T|ib1> */
#if CM(0,1,1)   /* v2.0.2++ ToDo: get fast tJ8u1d2e1 running ??? */
  { b->o=1;b_getbase(ib1,b);b->o=0; return(b->skfg); }
#endif
#if defined(CONFIG_S1SYM)
  if(sym.num_lm!=nn)
#if 0   /* v1.7.15++ */
  { b->o=1;b_getbase(ib1,b);b->o=0;return(b->skfg);}
#else
  { b->skfg=ib1=b_smallest_lm(ib1); ib2=b_smallest_lm(ib2);
    b->norm2*=b_factor_lm(ib1); }
#endif
#endif
  if( nu==nd ){
   if((ib2==ib1)){ n2=2;
    if(s2!=1){ b->sign=0; return TBASE0;}	/* s1!=1 */
   }
   if(!(ib1<=ib2)){ 
    ib3=ib1;b->skfg=ib1=ib2;ib2=ib3; b->sign=s2;s2=1; }	/* new minimum */
  }
  for(i=0;i<nn;i++){ ks[i]=k1[i]=geti(ib1,i); k2[i]=geti(ib2,i); }
  for(i2=0,k3=k1,s3=b->sign,ib3=ib1;;i2++,k3=k2,s3=s2,ib3=ib2){  /* ud=+1,-1 */
    for(j=0;j<sym.numall;j++){		/* take a SymOp=PermOp(j)=ps */
      for(ps=&sym.i[ j ][i=nn-1];;ps--){ /* Tj, high -> low */
        if((d=ks[i]-k3[ *ps ])<0) break;
        if(d!=0) { 
          for(k=i;k>=0;k--,ps--)ks[k]=k3[ *ps ];
          n2=1; 
#if CM(1,0,0)  /* signum is not cfg-dependend */
          s1=sym.w[ j ]; 
#elif CM(0,1,1)  /* signum is cfg-dependend */
          tbase ib4;
          get_symkonfig(ib3,j,&ib4,&s1,1);
#endif
          b->sign=s1*s3; 
          break; /* found smaller kfg */
        }
        if((--i)>=0) continue;
        /* get same konfig: S|k> to s|k> */
#if CM(1,0,0)  /* signum is not cfg-dependend */
        s1=sym.w[ j ];			/* T|x>=t|x> same konfig */
#elif CM(0,1,1)  /* signum is cfg-dependend */
        tbase ib4;
        get_symkonfig(ib3,j,&ib4,&s1,1);
#endif
        if(!phase_eq(s1*s3,b->sign)){b->sign=0;return TBASE0;} /* but other phase */
        n2++; break;
      } /* next site */
    }   /* test next sym */
    if(nu!=nd || i2>=1) break; /* Sep00 */
    IFww( break );
  }     /* test ud-sym */
  encode_ud( &(b->skfg), ks, nn);
  b->num=0;				/* not given here */
  b->norm2*=(((nu==nd)?2:1)*(sym.numall+1))/n2;	/* Ok ??? */
  /* if(norm2) b->norm2=(unsigned Tnorm2)norm2[lin(b->skfg)]; */
  return b->skfg;}


#define BLOCKS	8	/* can be only 2^n=1,2,4,8,etc */
/* version 0.1 Feb 2000 first try version, not finaly, for checks */
/* ideal way for part l1 into blocks => multi processing */
/* min=0 max=n*(n-1)/2 ??? besser mit Untergittern */
int block_no(tbase ib1){ /* use pair correlations, count d-d pairs */
  int no,i1,i2; no=0;
  if(sym.subl==2){	/* number of down spins in one SL */
    for(i2= 0;i2<nn;i2++)if(sym.sl[i2]==0) if(zi(ib1,i2)==-1) no++;
  } else 
  for(i2=   0;i2<nn;i2++)if(zi(ib1,i2)==-1)
  for(i1=i2+1;i1<nn;i1++)if(zi(ib1,i2)==-1)if( sym.korr[i2][i1]==1 || sym.korr[i2][i1]==12 ) no++;
  return no&(BLOCKS-1);
} 

ULong block_len[BLOCKS];

/* ----------------------------
 *  v1.7.13+ new ansatz, rekursiv addition of down-spins
 *    only for non-symmetric configs
 *    does only work for full symmetry and k=0
 */
#if CM(1,0,0)
ULLong numsymkonfJJ(int posd, int numd, tbase kfg1, int vv){
  struct sbase b; int i,iu,id; static int dd=0; ULLong num=0l;
  if( numd<=0 ){
    if ( vv&1 ){ printf(" %s\n",ckfg(kfg1)); }
    return 1l;
  }
  for(i=posd-1;i>=0;i--){
    kfg1|=((tbase)1)<<(nn-1-i); iu=nu; id=nd; dd++; nd=dd; nu=nn-nd;
    printf(" %s posd=%2d posd=%2d nd=%2d\n",ckfg(kfg1),posd,numd,nd);
    if(b_ifsmallest3(kfg1,&b))	/* nu,nd incorrect? */
    num+=numsymkonfJJ( i, numd-1, kfg1, vv );
    kfg1^=((tbase)1)<<(nn-1-i); nu=iu; nd=id; dd--;
  }
  return num;  /* liefert genau n1/2 ??? sortierung? */
}
#endif

/* --- all what be needed for pthreads of numsymkonf --- */
typedef struct sp_ns {
#ifdef CONFIG_PTHREAD
  pthread_t pt;
#endif
  ULLong i1,n;      /* idx of configuration */
  tbase ib1;        /* spin-configuration */
  ULLong i2,norm2,numans; /* counter */
  struct sbase b;   /* working buffer (big) */
  struct sp_ns *next; /* pointer to next data set */
  unsigned char *l1p; /* pointer to part of l1-table */
  ULLong l1s,l1l;     /* l1-stored, l1-len */
  minfo_t mi;
} tp_ns;

/* void-function for pthreads */
void ns_thread( void *ptr ){
    tp_ns *p=(tp_ns *)ptr;
    tbase ibold;
#if 0
    printf("start_thread %p\n",ptr);
#endif
    for( ibold = p->ib1 = ll1(p->i1); p->i1 < p->n; ){
#ifdef CONFIG_ANSATZ
      if(!ansatz_test(p->ib1)) p->numans++; else
#endif
      if(b_ifsmallest3(p->ib1,&(p->b))){
        p->i2++; p->norm2+=p->b.norm2;
        if (p->l1s >= p->l1l) {                 /* enlarge buffer */
          p->l1l+=4*1024; 
          p->l1p=(unsigned char *)myremalloc((void *)p->l1p,p->l1l*Bsize,&(p->mi));
          if (!p->l1p) ERR(9011); /* ToDo: myrealloc incl. fallback to mmap */
        }
        putl1(p->l1s,p->ib1,p->l1p); p->l1s++;  /* store minkfg */
        if(vvv&4)block_len[block_no(p->ib1)]++; /* ??? for future use */
      }
      p->i1++;
      p->ib1=next(p->ib1);        /* next higher config */
      if (p->ib1<=ibold) break; /* avoid overrun */
      ibold=p->ib1;
    }
#ifdef CONFIG_PTHREAD
/*  system("ps -H ux");system("sleep 10");printf("exit_thread %p\n",ptr);*/
    pthread_exit(0);
#endif
}


/* zahl der (symetrischen)basiszustaende(NN,nu,nd) -> n1 mit Sym 
 * nutzt sym,nu,nd zur berechnung! (speichern und vergleichen?) */
ULLong numsymkonf(){
#if defined(SBase) && (Sym+Sud>0)
  ULLong i1,i2,i3,i5,sum,numans; tp_ns pns,*ppns,*p2; int ii,i4;
  STKa("numsymkonf",(unsigned long *)&(pns.i1));
#if 0
  numans = numsymkonfJJ(nn,nd,(tbase)0,((nd<4 && vvv)?1:0));
  if(vvv) printf(" num_kfgJJ=%8lu\n",(unsigned long)numans);
#endif
  for(ii=0;ii<BLOCKS;ii++)block_len[ii]=0l;
  ppns=&pns; i4=1; i3=numkonf();
  if(vvv&1)printf(" numsymkonf(%.15g)",(double)i3);
#if Sud && CM(1,0,0)
  if( nu==nd && sym.num_lm==nn ) i3/=2; /* ??? does not work for LM<NN */
#endif                  
  if( sym.num_lm==nn ) i4=16;	/* steps for 16 threads */
  i5=i3/i4; /* length of blocks */
  if (sym.num_lm!=nn) { i4=1; i5=i3; } /* avoid a bug (s=1,JJ) */
  numans=i2=sum=0l; /* b.o 2=ifsmallest,1=smallest,0=fullbase */
  for( ii=0; ii<i4; ii++ ){ if(!ppns)ERR(9011);
    ppns->i1=ii*i5; ppns->n=((ii+1<i4)?(ii+1)*i5:i3); /* start; len */
    ppns->i2=0; ppns->norm2=0; ppns->numans=0; ppns->b.o=2;
    ppns->l1p=NULL;ppns->l1s=0;ppns->l1l=0;
    ppns->mi.p=NULL;  ppns->mi.l=0; ppns->mi.mode=8+1; /* remove mapfile */
    sprintf(ppns->mi.name,"tmp/l1_%03d.tmp",ii);  ppns->mi.ff=NULL;
#ifdef CONFIG_PTHREAD
    if( pthread_create((pthread_t *)&(ppns->pt),
                       (const pthread_attr_t *)NULL, 
                       (void * (*)(void *)) &ns_thread,
                       (void *)  ppns ) !=0 )  F0("pthread_create");
    if( ii<i4-1 ) ppns->next = (tp_ns *) malloc(sizeof(tp_ns)); ppns=ppns->next;
  }
  if(vvv)printf(" join threads");   /* easier to debug */
  for( ppns=&pns,ii=0; ii<i4; ii++ ){
    pthread_join(ppns->pt,NULL);
    i2+=ppns->i2; sum+=ppns->norm2; numans+=ppns->numans;
    save_l1(ppns->l1p,ppns->l1s,i2-ppns->i2);    
    myfree(ppns->l1p,&(ppns->mi));
    p2=ppns; ppns=ppns->next; if( ii>1 ) free(p2);
#else
    ns_thread( ppns );
    i2+=ppns->i2; sum+=ppns->norm2; numans+=ppns->numans;
    save_l1(ppns->l1p,ppns->l1s,i2-ppns->i2);    
    myfree(ppns->l1p,&(ppns->mi)); p2=ppns;
#endif
  }
  if(vvv&1){
    printf(" n1= %.15g n_ans= %.15g sum_n2= %.15g %s",
      (double)i2,(double)numans,(double)sum,sclock(~0l));
    if(sum!=i3) printf(" sum!=i3");
  }
  if(vvv&4)for(i1=0;i1<BLOCKS;i1++) printf("\n block_len[%2d]=%lu",(int)i1,block_len[i1]);
  STKe();return(i2);}
#else
  ULLong i1,numans=0,i2=numkonf(); tbase ib1; minfo_t mi;
  if (!l1) {
    fl1=fopen(FILE_l1,"r+b");
    if(!fl1)fl1=fopen(FILE_l1,"w+b"); if(!fl1) F1("fopen %s",FILE_l1);
    l1 = (unsigned char *) mymap(FILE_l1,fl1,(long)i2*Bsize,0);           
  }
  for( ib1 = ll1(i1=0l); i1 < i2; i1++,ib1=next(ib1)){
#ifdef CONFIG_ANSATZ
      if(!ansatz_test(ib1)) numans++; else
#endif
      putl1(i1,ib1,l1);
  }
  if(vvv&1) printf(" n1= %.15g n_ans= %.15g %s",(double)i2,(double)numans,sclock(~0l));
  return(i2);}
#endif

/* idee: l1 nach norm2 sortieren, um norm2 zu sparen */
#define N2Blen 1024 /* histogramsize */
int n2b[N2Blen]; /* histogram */

/* ----- initialisiere kfg-Tabellen l1 ab v1.5.3 ohne lin: l2a+l2b ----- */ 
/* last change 08.04.1998 JS because of bug! */
void lintab2(void){
/* da Lincodierung Anwendung der SymOp nicht spart, bringts nur wenig Gewinn */
/* und wird nicht benutzt, kommt wohl irgendwann weg */ 
  ULLong i1,sum2=0l,n2max=0; int i2;
  tbase ib1;
  static struct sbase b1 /* b2=tmp */;
  STKa("lintab",(unsigned long *)&i1); if(vvv&1)printf(" lintab");
  b1.o=0;

  if(base2ok)F0("darf nicht sein");
  
  err_pg(-1); /* reset errno for ERR(600) */
  for(i1=0l; i1<N2Blen; i1++) n2b[i1]=0;
  /* if (norm2) */
  for(i1=0l; i1<n1; i1++){  /* l1[] nach norm2[] sortieren??? */
   ib1=getl1((ULong)i1);
   b_ifsmallest3(ib1,&b1); sum2+=b1.norm2; /* sum2 == numkonf ! */
   if(b1.norm2 > n2max) n2max=b1.norm2;	/* store maximum => numsymkonf? */
   n2b[ ((b1.norm2 >= N2Blen)?0:b1.norm2) ]++;
   if (norm2){
     norm2[i1]=(Tnorm2)b1.norm2;
     if (((unsigned Tnorm2)b1.norm2)!=b1.norm2) 
     { ERR(600);norm2=(Tnorm2 *)myfree((void *)norm2, &m_n2); }
   }  
  }
  if (vvv) for(i1=0; i1<N2Blen; i1++)
    if (n2b[i1]) printf("\n norm2= %4d %8d times",(int)i1,n2b[i1]);
  printf(" n2max=%g",(double)n2max);
  if ( n2max >> (sizeof(Tnorm2)/2*8) == 0 )
    printf("\n# spare memory: Change Tnorm2 to short or char.\n");
  if (norm2) { if(!sum2)F0("sum_norm2==0"); base2ok=1; }
  if(vvv&1)printf(" sum_norm2=%.15g",(double)sum2);
  if(vvv&(32*4))
    for(i1=0l;i1<n1 && i1<16;i1++){	/* show base */
      b_getbase(getl1((ULong)i1),&b1);
      printf("\n %6d |%.15g>=",(int)b1.norm2,(double)i1);
      for(i2=0l;i2<b1.num;i2++) 
        printf(" %s*%s",outphase(b1.is[i2]),ckfg(b1.ib[i2])); 
    }
  
  if(vvv&1)printf(" %s",sclock(~0l));
  STKe();return;
}


/* last modification: 
   1998-148 type tbase j,m durch ulong ersetzt etc.
   Dez98: allg. tbase-type unabhaengige linfkt. + better errorhandling
 */

/* static inline */
/* g++ braucht 2 mal laenger, a.out fiept auf sun, a.out nicht schneller 
 *    vielleicht sollte man auf lintab verzichten???
 *    heisst zwar noch lin, lin-Kodierung wird aber nicht mehr benutzt
 */
ULong lin_if_err(tbase i){	/* called if error in lin() occurs */
  ULong j,m; static int err=0; static ULong m2=1l;
#ifdef SBase
  static struct sbase b; /* ohne static - storeh 100 mal laenger, only used if error */
#endif /* SBase */
  while ((m2<<1)<n1) m2<<=1;	/* Feb00 */
  for(j=0l,m=m2;m;m>>=1){if((j|m)<n1)if( (getl1(j|m)<=i) )j|=m;}
  if (getl1(j)==i) return j;
  {			/* not found */
   if(++err<5)printf("\n ups,     %s not found",ckfg(i));
#if defined(SBase)
   b.o=0;
   b_smallest(i,&b);if(err<5)printf("\n kfg_sm = %s * %s",ckfg(b.skfg),outphase(b.sign));
   b_getbase( i,&b);if(err<5)printf("\n kfg_gb = %s * %s",ckfg(b.skfg),outphase(b.sign));
   i=b.skfg;
#endif
   for(j=0l,m=m2;m;m>>=1){ if((j|m)<n1)if((getl1(j|m)<=i))j|=m; }
   if(!(getl1(j)==i)){       /* wieder nicht gefunden !!! */
     if(err<3){
       if(j  >(ULong)0) printf("\nl1[%5lu]=%s",0l,ckfg(getl1(0l)));
       if(j  >(ULong)1) printf("\nl1[%5lu]=%s",1l,ckfg(getl1(1l)));
       if(j-2<n1) printf("\nl1[%5lu]=%s",j-2,ckfg(getl1(j-2)));
       if(j-1<n1) printf("\nl1[%5lu]=%s",j-1,ckfg(getl1(j-1)));
       if(j  <n1) printf("\nl1[%5lu]=%s",j  ,ckfg(getl1(j  )));
       if(j+1<n1) printf("\nl1[%5lu]=%s",j+1,ckfg(getl1(j+1)));
       ERR(400); 
     }
     for(j=0;j<n1;j++)if(getl1(j)==i) break; /* l1 not sorted? */
     if(j==n1)if(err<10){ ERR(410); err_fatal++; }
   }
   if(err<5)printf("\n now lin() is ok");
  }
  return(j);}

/* the routine is short as possible to fit into the cache
   input is spin-konfiguration (representator)
   output is index to tables
 */
ULong lin(tbase i){
  ULong j,m; static ULong m2=1l;
  while ((m2<<1)<n1) m2<<=1;	/* Feb00 */
  for(j=0l,m=m2;m;m>>=1){if((j|m)<n1)if( (getl1(j|m)<=i) )j|=m;}
  if (getl1(j)==i) return j;
#if !defined(DEBUG)
  return n1;
#else
  return lin_if_err(i); /* error-routine outside the cpu-cache */
#endif
}

/* geht nicht bei N=5 Kette!??? */
/* faster version of makesym for l==2, Zahl & 4 variante ueberdenken! 
   v1 = |v0> <v0| (f*T + T^2) |v0>;  f={+1,-1}; T^2=1
 */
zahl makesym2(tvec *v0,tvec *v1,int d,int kk){     /* v1 may be v0!? */
  ULong i,i2;tbase ib2;tphase s,f;cplx a,b,r,r2,rh;zahl rn,tn;
  rh=rn=0.0; /* #if Zahl & 4\n f=C(1-2*kk,0);\n#else\nf=1-2*kk\n#endif\n */  
  f=1-2*kk;				/* f=exp(I*2*Pi*kk/2)={+1,-1} */
  for(i=0l;i<n1;i++){                   /* all |i>  of  Sum v0[i] |i> */
    get_symkonfig(getl1(i),d,&ib2,&s,1);i2=lin(ib2); /* i2 = Td |i> */
    if(i2==i){					  /* same config */
      if(D(s*f)>0.1)r=2*vec_e(v0,i);else r=0.;
      if(A_ptr(v1))*vec_pe(v1,i)=M_d2f(r);
      rn+=Norm(r);rh+=r*vec_e(v0,i);
    } 
    else if(i2<=i){
      a=vec_e(v0,i);b=vec_e(v0,i2);r=a+s*f*b;r2=b+s*f*a;
      if(A_ptr(v1)){*vec_pe(v1,i)=M_d2f(r);*vec_pe(v1,i2)=M_d2f(r2);}
      rn+=2*Norm(r);rh+=a*r+b*r2;}}  
  if(rn>0.0){tn=1./sqrt(rn);rh*=tn;
  if(rn<1.0)for(i=0l;i<n1;i++)*vec_pe(v1,i)=M_d2f(tn*vec_e(v1,i));} /* call mltply_av */
  if(vvv&1){ printf(" T%d <%d>=%g",d,kk,(double)Norm(rh));}
  return Re(rh);}

/* symmetrisiere v0: v1(=v0)=v0 + (f)*SymOp_d*v0, [SymOp,H]=0, f=exp(i*kk) */
/* v1 = |v0> <v0| sum_{n=1..l} (exp(ik)T)^n |v0> ??? */
zahl makesym(tvec *v0,tvec *v1,int d,int kk){
  ULong i;tbase ib2;tphase s;zahl rn;
  cplx rh,th,tc,ts,fn,fc,fs,tn,rr[NN],rc[NN],rs[NN];
  ULong j,jj[NN];tbase ib1;tphase s1,ss[NN];int k,l,m;
  l=sym.l[d];fn=rh=fc=fs=rn=0.0;
  /* if(kk<=l/2)k2=kk;else k2=kk-l/2; */
  if(l==2)return(makesym2(v0,v1,d,kk));		/* l==2 faster */
  for(k=0;k<l;k++)rc[k]=cos((2*M_PI*k)/l);	/* sqrt(2/l) */
  for(k=0;k<l;k++)rs[k]=sin((2*M_PI*k)/l);
  for(i=0l;i<n1;i++){ ib2=getl1(i);s1=1;
    th=tn=0.0;rr[0]=vec_e(v0,i);ss[0]=s1;jj[0]=i;k=0;	/* i ist kleinste konfig */
    for(m=1;m<l;m++){ ib1=ib2;
      get_symkonfig(ib1,d,&ib2,&s,1);j=lin(ib2);s1*=s; /* s|j>=T|i> */
      rr[m]=vec_e(v0,j);ss[m]=s1;jj[m]=j;if(j<=i){k=1;break;}}
    if(k)continue;		/* nur einmal fuer alle T^i|x> */
    th=ts=tc=0.0;
    for(m=0;m<l;m++){			/* get phase of |x> */
      tc+= rr[m]*ss[m]*rc[(kk*m)%l];
      ts+=-rr[m]*ss[m]*rs[(kk*m)%l];
      th+=Norm(rr[m]);}
    /* tc*=sqrt(1./l);ts*=sqrt(1./l);  */	tc*=(2./l);ts*=(2./l);  
    tn=(Norm(tc)+Norm(ts));/* printf("\nphase (%g %g)",tc,ts); */
    /* printf("\nratio %g/%g",tn,th); */	if(fabs(tn)<1e-15)continue;
    if(fn==0.0){ 
      fc=tc/sqrt(tn);fs=-ts/sqrt(tn);fn=tn;
      /* printf("(%g,%g)",fc,fs); */}
    tn=tc*fc-ts*fs;ts=tc*fs+ts*fc;tc=tn;/* Rueckdrehung */
    if(kk>l/2){tn=-ts;ts=tc;tc=tn;}	/* rotate Pi/2 (imaginary part) */
    for(m=0;m<l;m++){			/* alle T^i|x> */
      /* printf("\n %g*%g %s",v0[jj[m]],tc,ckfg(getl1(jj[m])));*/
      rh+=vec_e(v0,jj[m])*tc;rn+=Norm(tc);	/* <v0|k>	*/
      if(A_ptr(v1))*vec_pe(v1,jj[m])=M_d2f(tc); /* <v0|k>|k>	*/ 
      tn=tc*rc[kk]-ts*rs[kk];		/* Drehung um kk	*/
      ts=tc*rs[kk]+ts*rc[kk];tc=tn;} }
  if(rn>0.0){tn=1./sqrt(rn);rh*=Re(tn);
  if(rn<1.0)for(i=0l;i<n1;i++)*vec_pe(v1,i)=M_d2f(tn*vec_e(v1,i));} /* ??? av */
  if(vvv&1){ printf(" T%d <%d>=%g",d,kk,(double)Norm(rh));}
  return Re(rh);}
   
